﻿using System;
using System.Linq;
using System.Text;
using System.Web.UI;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace DisplayASimpleMap
{
    public partial class _Default : System.Web.UI.Page, ICallbackEventHandler
    {
        private string callbackResult;

        public string GetCallbackResult()
        {
            return callbackResult;
        }

        public void RaiseCallbackEvent(string eventArgument)
        {
            PointShape worldCoordinate = new PointShape(eventArgument);
            //ScreenPointF worldCoordinate = new ScreenPointF((float)screenPoint.X, (float)screenPoint.Y);

            //PointShape worldPoint = Map1.ToWorldCoordinate(screenPointF);

            ShapeFileFeatureLayer worldLayer = (Map1.CustomOverlays["worldoverlay"] as LayerOverlay).Layers["worldLayer"] as ShapeFileFeatureLayer;

            worldLayer.FeatureSource.Open();

            Feature hoverOnFeature = worldLayer.QueryTools.GetFeaturesContaining(new Feature(worldCoordinate.X, worldCoordinate.Y), ReturningColumnsType.AllColumns).FirstOrDefault();
            StringBuilder popupHtml = new StringBuilder("<p>");
            if (hoverOnFeature != null)
            {
                popupHtml.Append(hoverOnFeature.ColumnValues["CNTRY_NAME"]);
            }
            else
            {
                popupHtml.Append("No Contry Here");
            }
            popupHtml.Append("</p>");

            callbackResult = popupHtml.ToString();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
                Map1.CurrentExtent = new RectangleShape(-163.4, 41.9, -60.1, 30.3);
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(MapPath("~/Data/cntry02.shp"));
                worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;

                LayerOverlay staticOverlay = new LayerOverlay("worldoverlay");
                staticOverlay.IsBaseOverlay = false;
                staticOverlay.Layers.Add("worldLayer", worldLayer);
                Map1.CustomOverlays.Add(staticOverlay);

                // Add hover-popup
                CloudPopup featureinfoPopup = new CloudPopup("featureInfoPopup", new PointShape(0, 0), "State Info"); // make the popup out of map view temporarily
                featureinfoPopup.AutoSize = true;
                featureinfoPopup.HasCloseButton = true;
                featureinfoPopup.IsVisible = false;
                Map1.Popups.Add(featureinfoPopup);
            }
        }
    }
}